<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateRacunFromWebRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateRacunFromWebRequest
 * @subpackage Structs
 */
class CreateRacunFromWebRequest extends AbstractStructBase
{
    /**
     * The BrojRata
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $BrojRata;
    /**
     * The Iznos
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Iznos;
    /**
     * The KupacAdresa
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KupacAdresa;
    /**
     * The KupacGrad
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KupacGrad;
    /**
     * The KupacNaziv
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KupacNaziv;
    /**
     * The KupacOib
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KupacOib;
    /**
     * The KupacPBr
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KupacPBr;
    /**
     * The NacinPlacanja
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NacinPlacanja;
    /**
     * The Protokol
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Protokol;
    /**
     * The UpisPoId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $UpisPoId;
    /**
     * The UpisTecajIds
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $UpisTecajIds;
    /**
     * The VrstaKarticeBanka
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VrstaKarticeBanka;
    /**
     * Constructor method for CreateRacunFromWebRequest
     * @uses CreateRacunFromWebRequest::setBrojRata()
     * @uses CreateRacunFromWebRequest::setIznos()
     * @uses CreateRacunFromWebRequest::setKupacAdresa()
     * @uses CreateRacunFromWebRequest::setKupacGrad()
     * @uses CreateRacunFromWebRequest::setKupacNaziv()
     * @uses CreateRacunFromWebRequest::setKupacOib()
     * @uses CreateRacunFromWebRequest::setKupacPBr()
     * @uses CreateRacunFromWebRequest::setNacinPlacanja()
     * @uses CreateRacunFromWebRequest::setProtokol()
     * @uses CreateRacunFromWebRequest::setUpisPoId()
     * @uses CreateRacunFromWebRequest::setUpisTecajIds()
     * @uses CreateRacunFromWebRequest::setVrstaKarticeBanka()
     * @param int $brojRata
     * @param float $iznos
     * @param string $kupacAdresa
     * @param string $kupacGrad
     * @param string $kupacNaziv
     * @param string $kupacOib
     * @param string $kupacPBr
     * @param string $nacinPlacanja
     * @param int $protokol
     * @param int $upisPoId
     * @param \ArrayType\ArrayOfint $upisTecajIds
     * @param string $vrstaKarticeBanka
     */
    public function __construct($brojRata = null, $iznos = null, $kupacAdresa = null, $kupacGrad = null, $kupacNaziv = null, $kupacOib = null, $kupacPBr = null, $nacinPlacanja = null, $protokol = null, $upisPoId = null, \ArrayType\ArrayOfint $upisTecajIds = null, $vrstaKarticeBanka = null)
    {
        $this
            ->setBrojRata($brojRata)
            ->setIznos($iznos)
            ->setKupacAdresa($kupacAdresa)
            ->setKupacGrad($kupacGrad)
            ->setKupacNaziv($kupacNaziv)
            ->setKupacOib($kupacOib)
            ->setKupacPBr($kupacPBr)
            ->setNacinPlacanja($nacinPlacanja)
            ->setProtokol($protokol)
            ->setUpisPoId($upisPoId)
            ->setUpisTecajIds($upisTecajIds)
            ->setVrstaKarticeBanka($vrstaKarticeBanka);
    }
    /**
     * Get BrojRata value
     * @return int|null
     */
    public function getBrojRata()
    {
        return $this->BrojRata;
    }
    /**
     * Set BrojRata value
     * @param int $brojRata
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setBrojRata($brojRata = null)
    {
        // validation for constraint: int
        if (!is_null($brojRata) && !is_numeric($brojRata)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($brojRata)), __LINE__);
        }
        $this->BrojRata = $brojRata;
        return $this;
    }
    /**
     * Get Iznos value
     * @return float|null
     */
    public function getIznos()
    {
        return $this->Iznos;
    }
    /**
     * Set Iznos value
     * @param float $iznos
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setIznos($iznos = null)
    {
        $this->Iznos = $iznos;
        return $this;
    }
    /**
     * Get KupacAdresa value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKupacAdresa()
    {
        return isset($this->KupacAdresa) ? $this->KupacAdresa : null;
    }
    /**
     * Set KupacAdresa value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kupacAdresa
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setKupacAdresa($kupacAdresa = null)
    {
        // validation for constraint: string
        if (!is_null($kupacAdresa) && !is_string($kupacAdresa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kupacAdresa)), __LINE__);
        }
        if (is_null($kupacAdresa) || (is_array($kupacAdresa) && empty($kupacAdresa))) {
            unset($this->KupacAdresa);
        } else {
            $this->KupacAdresa = $kupacAdresa;
        }
        return $this;
    }
    /**
     * Get KupacGrad value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKupacGrad()
    {
        return isset($this->KupacGrad) ? $this->KupacGrad : null;
    }
    /**
     * Set KupacGrad value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kupacGrad
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setKupacGrad($kupacGrad = null)
    {
        // validation for constraint: string
        if (!is_null($kupacGrad) && !is_string($kupacGrad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kupacGrad)), __LINE__);
        }
        if (is_null($kupacGrad) || (is_array($kupacGrad) && empty($kupacGrad))) {
            unset($this->KupacGrad);
        } else {
            $this->KupacGrad = $kupacGrad;
        }
        return $this;
    }
    /**
     * Get KupacNaziv value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKupacNaziv()
    {
        return isset($this->KupacNaziv) ? $this->KupacNaziv : null;
    }
    /**
     * Set KupacNaziv value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kupacNaziv
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setKupacNaziv($kupacNaziv = null)
    {
        // validation for constraint: string
        if (!is_null($kupacNaziv) && !is_string($kupacNaziv)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kupacNaziv)), __LINE__);
        }
        if (is_null($kupacNaziv) || (is_array($kupacNaziv) && empty($kupacNaziv))) {
            unset($this->KupacNaziv);
        } else {
            $this->KupacNaziv = $kupacNaziv;
        }
        return $this;
    }
    /**
     * Get KupacOib value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKupacOib()
    {
        return isset($this->KupacOib) ? $this->KupacOib : null;
    }
    /**
     * Set KupacOib value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kupacOib
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setKupacOib($kupacOib = null)
    {
        // validation for constraint: string
        if (!is_null($kupacOib) && !is_string($kupacOib)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kupacOib)), __LINE__);
        }
        if (is_null($kupacOib) || (is_array($kupacOib) && empty($kupacOib))) {
            unset($this->KupacOib);
        } else {
            $this->KupacOib = $kupacOib;
        }
        return $this;
    }
    /**
     * Get KupacPBr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKupacPBr()
    {
        return isset($this->KupacPBr) ? $this->KupacPBr : null;
    }
    /**
     * Set KupacPBr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kupacPBr
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setKupacPBr($kupacPBr = null)
    {
        // validation for constraint: string
        if (!is_null($kupacPBr) && !is_string($kupacPBr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kupacPBr)), __LINE__);
        }
        if (is_null($kupacPBr) || (is_array($kupacPBr) && empty($kupacPBr))) {
            unset($this->KupacPBr);
        } else {
            $this->KupacPBr = $kupacPBr;
        }
        return $this;
    }
    /**
     * Get NacinPlacanja value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNacinPlacanja()
    {
        return isset($this->NacinPlacanja) ? $this->NacinPlacanja : null;
    }
    /**
     * Set NacinPlacanja value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nacinPlacanja
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setNacinPlacanja($nacinPlacanja = null)
    {
        // validation for constraint: string
        if (!is_null($nacinPlacanja) && !is_string($nacinPlacanja)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nacinPlacanja)), __LINE__);
        }
        if (is_null($nacinPlacanja) || (is_array($nacinPlacanja) && empty($nacinPlacanja))) {
            unset($this->NacinPlacanja);
        } else {
            $this->NacinPlacanja = $nacinPlacanja;
        }
        return $this;
    }
    /**
     * Get Protokol value
     * @return int|null
     */
    public function getProtokol()
    {
        return $this->Protokol;
    }
    /**
     * Set Protokol value
     * @param int $protokol
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setProtokol($protokol = null)
    {
        // validation for constraint: int
        if (!is_null($protokol) && !is_numeric($protokol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($protokol)), __LINE__);
        }
        $this->Protokol = $protokol;
        return $this;
    }
    /**
     * Get UpisPoId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getUpisPoId()
    {
        return isset($this->UpisPoId) ? $this->UpisPoId : null;
    }
    /**
     * Set UpisPoId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $upisPoId
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setUpisPoId($upisPoId = null)
    {
        // validation for constraint: int
        if (!is_null($upisPoId) && !is_numeric($upisPoId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($upisPoId)), __LINE__);
        }
        if (is_null($upisPoId) || (is_array($upisPoId) && empty($upisPoId))) {
            unset($this->UpisPoId);
        } else {
            $this->UpisPoId = $upisPoId;
        }
        return $this;
    }
    /**
     * Get UpisTecajIds value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getUpisTecajIds()
    {
        return isset($this->UpisTecajIds) ? $this->UpisTecajIds : null;
    }
    /**
     * Set UpisTecajIds value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $upisTecajIds
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setUpisTecajIds(\ArrayType\ArrayOfint $upisTecajIds = null)
    {
        if (is_null($upisTecajIds) || (is_array($upisTecajIds) && empty($upisTecajIds))) {
            unset($this->UpisTecajIds);
        } else {
            $this->UpisTecajIds = $upisTecajIds;
        }
        return $this;
    }
    /**
     * Get VrstaKarticeBanka value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVrstaKarticeBanka()
    {
        return isset($this->VrstaKarticeBanka) ? $this->VrstaKarticeBanka : null;
    }
    /**
     * Set VrstaKarticeBanka value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vrstaKarticeBanka
     * @return \StructType\CreateRacunFromWebRequest
     */
    public function setVrstaKarticeBanka($vrstaKarticeBanka = null)
    {
        // validation for constraint: string
        if (!is_null($vrstaKarticeBanka) && !is_string($vrstaKarticeBanka)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vrstaKarticeBanka)), __LINE__);
        }
        if (is_null($vrstaKarticeBanka) || (is_array($vrstaKarticeBanka) && empty($vrstaKarticeBanka))) {
            unset($this->VrstaKarticeBanka);
        } else {
            $this->VrstaKarticeBanka = $vrstaKarticeBanka;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateRacunFromWebRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
